procedure mask1d(imlist, imout, immask, xpos, ypos)

file    imlist          {prompt = "Input image"}
file    imout           {prompt = "Output image"}
file    immask          {prompt = "Mask image"}
int     xpos            {prompt = "X-position of measurement of Y-position"}
int     ypos            {prompt = "Y-position of the spectra"}

struct  *list5    {mode = 'h'}
#
#
begin
        string  openfile, maskfile, savefile
        string  tmpimage1, tmpimage2

        int     naxis1,naxis2 
        real    aa,bb,cc
        real    x_pos, y_pos, offset
        string  wcs
        struct  command
        string  key

        openfile = imlist
        savefile = imout
        maskfile = immask
        y_pos = ypos
        x_pos = xpos

        list5 = ""
        tmpimage1  = mktemp( "tmp_im." )
        tmpimage2  = mktemp( "tmp_im." )

# get header information from mask image
        imgets(maskfile,"MASKA") 
        aa=real(imgets.value)
        imgets(maskfile,"MASKB") 
        bb=real(imgets.value)
        imgets(maskfile,"MASKC") 
        cc=real(imgets.value)
        offset=y_pos-(aa*x_pos*x_pos+bb*x_pos+cc)
#        print(aa,bb,cc)

        imgets(openfile,"naxis1") 
        naxis1=int(imgets.value)
        imgets(openfile,"naxis2") 
        naxis2=int(imgets.value)
#        print(naxis1,naxis2)

        if( x_pos!=0 && y_pos!=0 ){
        imlintran(maskfile, tmpimage1, 0., 0., 1.0, 1.0, xin=1, yin=1, xout=1, yout=1, nlines=naxis2,boundar="constant", constan=0.0)
        imshift(tmpimage1, tmpimage1, 0.0, offset, interp='linear', boundar='constant', constan=0.)
        }
        else {
        imcopy(maskfile, tmpimage1,>&"dev$null")
        }
        imarith(openfile, "*", tmpimage1//"[1:"//naxis1//",1:"//naxis2//"]", tmpimage2 )
        blkavg(tmpimage2, savefile, 1, 1024,option = "sum" )

        print("Yshift= ",offset)


finish:
        imdelete( tmpimage1,ver-,>&"dev$null" )
        imdelete( tmpimage2,ver-,>&"dev$null" )
        bye
end
